=== debian/changelog ===
libevhtp (1.2.9-1) unstable; urgency=medium

  * New upstream release.
  * Remove status_code_tree_* from the ABI.
  * Move documentation to a dedicated package.

 -- Vincent Bernat <bernat@debian.org>  Sun, 25 May 2014 13:12:25 +0200

libevhtp (1.2.8-1) unstable; urgency=low

  * Initial release. Closes: #710378.

 -- Vincent Bernat <bernat@debian.org>  Tue, 04 Feb 2014 21:18:20 +0100
