=== debian/control ===
Source: libevhtp
Section: libs
Priority: optional
Maintainer: Vincent Bernat <bernat@debian.org>
Standards-Version: 3.9.5
Build-Depends: debhelper (>= 9),
               cmake,
               libevent-dev,
               libonig-dev,
               libssl-dev,
               doxygen
Homepage: https://github.com/ellzey/libevhtp
Vcs-Git: git://anonscm.debian.org/collab-maint/libevhtp.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/libevhtp.git;a=summary

Package: libevhtp0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Libevent based HTTP API
 Libevent's http interface was created as a JIT server, never meant to
 be a full-fledged HTTP service.  This library attempts to improve on
 that with the following features:
 .
  + design as a fully functional HTTP server
  + HTTP parser able to process data with a low memory footprint
  + use of regular expressions for routing
  + out-of-the box HTTPS server
 .
 This package contains the runtime library.

Package: libevhtp-dev
Section: libdevel
Architecture: any
Depends: libevhtp0 (= ${binary:Version}), ${misc:Depends}
Description: Libevent based HTTP API - development files
 Libevent's http interface was created as a JIT server, never meant to
 be a full-fledged HTTP service.  This library attempts to improve on
 that.
 .
 This package contains the development library.

Package: libevhtp0-dbg
Architecture: any
Multi-Arch: same
Section: debug
Priority: extra
Depends: libevhtp0 (= ${binary:Version}), ${misc:Depends}
Description: Libevent based HTTP API - debugging symbols
 Libevent's http interface was created as a JIT server, never meant to
 be a full-fledged HTTP service.  This library attempts to improve on
 that.
 .
 This package contains the debugging symbols.

Package: libevhtp-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Breaks: libevhtp-dev (<= 1.2.8-1)
Replaces: libevhtp-dev (<= 1.2.8-1)
Description: Libevent based HTTP API - documentation
 Libevent's http interface was created as a JIT server, never meant to
 be a full-fledged HTTP service.  This library attempts to improve on
 that.
 .
 This package contains the documentation and examples.
