=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DEVHTP_BUILD_SHARED:STRING=ON

override_dh_auto_build:
	dh_auto_build
	doxygen

override_dh_auto_install:
	dh_auto_install
	# CMake does not support to specify the directory where to put multiarch stuff
	mkdir debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	mv debian/tmp/usr/lib/lib* debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_strip:
	dh_strip --dbg-package=libevhtp0-dbg

override_dh_auto_clean:
	dh_auto_clean
	rm -rf docs
