## libevhtp 1.2.10

=== debian/changelog ===
libevhtp (1.2.10-3) unstable; urgency=medium

  * Make documentation build reproducible.

 -- Vincent Bernat <bernat@debian.org>  Thu, 20 Aug 2015 10:15:43 +0200

libevhtp (1.2.10-2) unstable; urgency=medium

  * Make libevhtp-dev depends on libonig-dev. Closes: #788862.

 -- Vincent Bernat <bernat@debian.org>  Mon, 15 Jun 2015 22:11:57 +0200

libevhtp (1.2.10-1) unstable; urgency=medium

  * New upstream release. Closes: #781575.
     + Remove unneeded patches.
  * Install .pc file in -dev package.
  * Update symbol files.
  * Update lintian override for jQuery.
  * Bump Standards-Version.

 -- Vincent Bernat <bernat@debian.org>  Sun, 26 Apr 2015 18:20:50 +0200
