=== debian/rules ===
--- 
+++ 
@@ -16,8 +16,9 @@
 override_dh_auto_install:
 	dh_auto_install
 	# CMake does not support to specify the directory where to put multiarch stuff
-	mkdir debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
+	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig
 	mv debian/tmp/usr/lib/lib* debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
+	mv debian/tmp/usr/lib/pkgconfig debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
 
 override_dh_strip:
 	dh_strip --dbg-package=libevhtp0-dbg
