=== debian/changelog ===
libevhtp (1.2.11-3) unstable; urgency=medium

  * Suggests libevhtp-doc when installing libevhtp-dev. Closes: #849603.

 -- Vincent Bernat <bernat@debian.org>  Thu, 29 Dec 2016 09:06:15 +0100

libevhtp (1.2.11-2) unstable; urgency=medium

  * Build-Depends on libssl1.0-dev. Thanks to Adrian Bunk for the
    patch. Closes: #828394.
  * Bump Standards-Version.
  * Update Vcs-* fields.

 -- Vincent Bernat <bernat@debian.org>  Sun, 11 Dec 2016 14:00:16 +0100

libevhtp (1.2.11-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches and remove reproducible-build.patch (HTML_TIMESTAMP is
    set to NO by default).

 -- Vincent Bernat <bernat@debian.org>  Sat, 21 Nov 2015 13:45:48 +0100
