=== debian/control ===
--- 
+++ 
@@ -2,16 +2,16 @@
 Section: libs
 Priority: optional
 Maintainer: Vincent Bernat <bernat@debian.org>
-Standards-Version: 3.9.5
+Standards-Version: 3.9.8
 Build-Depends: debhelper (>= 9),
                cmake,
                libevent-dev,
                libonig-dev,
-               libssl-dev,
+               libssl1.0-dev | libssl-dev (<< 1.1.0~),
                doxygen
 Homepage: https://github.com/ellzey/libevhtp
-Vcs-Git: git://anonscm.debian.org/collab-maint/libevhtp.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/libevhtp.git;a=summary
+Vcs-Git: https://alioth.debian.org/anonscm/git/collab-maint/libevhtp.git
+Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/libevhtp.git
 
 Package: libevhtp0
 Architecture: any
@@ -32,7 +32,8 @@
 Package: libevhtp-dev
 Section: libdevel
 Architecture: any
-Depends: libevhtp0 (= ${binary:Version}), ${misc:Depends}
+Depends: libevhtp0 (= ${binary:Version}), libonig-dev, ${misc:Depends}
+Suggests: libevhtp-doc
 Description: Libevent based HTTP API - development files
  Libevent's http interface was created as a JIT server, never meant to
  be a full-fledged HTTP service.  This library attempts to improve on
