=== debian/rules ===
--- 
+++ 
@@ -11,6 +11,7 @@
 
 override_dh_auto_build:
 	dh_auto_build
+	mkdir -p html
 	doxygen
 
 override_dh_auto_install:
@@ -25,4 +26,4 @@
 
 override_dh_auto_clean:
 	dh_auto_clean
-	rm -rf docs
+	rm -rf html
