=== debian/changelog ===
libevhtp (1.2.16-1) unstable; urgency=medium

  * New upstream release.
  * d/patches: drop all patches.
  * d/symbols: update.

 -- Vincent Bernat <bernat@debian.org>  Sat, 27 Jan 2018 17:13:42 +0100

libevhtp (1.2.15-1) unstable; urgency=medium

  * New upstream release.
     + Support for OpenSSL 1.1. Closes: #859052.
  * d/patches: drop all patches.
  * d/patches: fix compilation with shared libraries.
  * d/symbols: update (breaking ABI, but no reverse dependencies).
  * d/copyright: no more shipped version of oniguruma regex library.
  * d/control: bump Standards-Version.

 -- Vincent Bernat <bernat@debian.org>  Thu, 07 Dec 2017 07:08:46 +0100

libevhtp (1.2.12-1) unstable; urgency=medium

  * New upstream release.
     + Drop evhtp.pc install patch. Applied upstream.
     + Update d/symbols.
     + Add back evthr_new() symbol removed by error.
  * Update project URL in d/{copyright,control,watch}. Closes: #874442.
  * d/control: bump Standards-Version.
  * d/control: remove manual -dbg package (use -dbgsym).

 -- Vincent Bernat <bernat@debian.org>  Fri, 13 Oct 2017 13:46:58 +0200
