=== debian/control ===
--- 
+++ 
@@ -2,14 +2,14 @@
 Section: libs
 Priority: optional
 Maintainer: Vincent Bernat <bernat@debian.org>
-Standards-Version: 3.9.8
+Standards-Version: 4.1.2
 Build-Depends: debhelper (>= 9),
                cmake,
                libevent-dev,
                libonig-dev,
-               libssl1.0-dev | libssl-dev (<< 1.1.0~),
+               libssl-dev,
                doxygen
-Homepage: https://github.com/ellzey/libevhtp
+Homepage: https://github.com/criticalstack/libevhtp
 Vcs-Git: https://alioth.debian.org/anonscm/git/collab-maint/libevhtp.git
 Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/libevhtp.git
 
@@ -41,19 +41,6 @@
  .
  This package contains the development library.
 
-Package: libevhtp0-dbg
-Architecture: any
-Multi-Arch: same
-Section: debug
-Priority: extra
-Depends: libevhtp0 (= ${binary:Version}), ${misc:Depends}
-Description: Libevent based HTTP API - debugging symbols
- Libevent's http interface was created as a JIT server, never meant to
- be a full-fledged HTTP service.  This library attempts to improve on
- that.
- .
- This package contains the debugging symbols.
-
 Package: libevhtp-doc
 Section: doc
 Architecture: all
