=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,7 @@
 	mv debian/tmp/usr/lib/pkgconfig debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
 
 override_dh_strip:
-	dh_strip --dbg-package=libevhtp0-dbg
+	dh_strip --dbgsym-migration='libevhtp0-dbg (<< 1.2.11-3~)'
 
 override_dh_auto_clean:
 	dh_auto_clean
